<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label=" 题目内容 " prop="topic">

        <el-input v-model="queryParams.topic" placeholder="请输入 题目内容 " clearable @keyup.enter.native="handleQuery" />


      </el-form-item>


      <el-form-item label=" 机构ID " prop="orgid">



        <el-input v-model="queryParams.orgid" placeholder="请输入 机构ID " clearable @keyup.enter.native="handleQuery" />



      </el-form-item>







      <el-form-item label=" 是否隐藏 " prop="ishide">







        <el-select v-model="queryParams.ishide" placeholder="请选择 是否隐藏 " clearable>







          <el-option v-for="dict in dict.type.sys_yes_no" :key="dict.value" :label="dict.label" :value="dict.value" />







        </el-select>







      </el-form-item>







      <el-form-item>







        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>







        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>







      </el-form-item>







    </el-form>



    <el-row :gutter="10" class="mb8">

      <el-col :span="1.5">



        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['smartor:svytopic:add']">新增</el-button>



      </el-col>



      <el-col :span="1.5">




        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['smartor:svytopic:edit']">修改</el-button>







      </el-col>







      <el-col :span="1.5">







        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['smartor:svytopic:remove']">删除</el-button>







      </el-col>







      <el-col :span="1.5">







        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['smartor:svytopic:export']">导出</el-button>







      </el-col>







      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>







    </el-row>















    <el-table v-loading="loading" :data="svytopicList" @selection-change="handleSelectionChange">







      <el-table-column type="selection" width="55" align="center" />







      <el-table-column label=" 题目类型 " align="center" prop="topictype" />







      <el-table-column label=" 题目 " align="center" prop="topic" />







      <el-table-column label=" 是否隐藏 " align="center" prop="ishide">







        <template slot-scope="scope">







          <dict-tag :options="dict.type.sys_yes_no" :value="scope.row.ishide" />
        </template>
      </el-table-column>
      <el-table-column label=" 归属机构 " align="center" prop="orgid" />
      <el-table-column label=" 创建时间 " align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['smartor:svytopic:edit']">







            修改</el-button>







          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['smartor:svytopic:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改问卷题目对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="1000px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-row><el-col :span="8">
            <el-form-item label=" 题目编号" prop="topiccode">
              <el-input v-model="form.topiccode" placeholder="请输入 题目编号 " />
            </el-form-item> </el-col><el-col :span="8">
            <el-form-item label=" 题目类型 " prop="topictype">
              <el-select v-model="form.topictype" placeholder="请选择">
                <el-option label="单选" value="1"></el-option>
                <el-option label="多选" value="2"></el-option>
                <el-option label="填空" value="3"></el-option>
              </el-select>
            </el-form-item> </el-col>
          <el-col :span="8"><el-form-item label=" 是否必填 " prop="ismandatory">
              <el-select v-model="form.ismandatory" placeholder="请选择 是否必填 ">
                <el-option v-for="dict in dict.type.sys_yes_no" :key="dict.value" :label="dict.label"
                  :value="parseInt(dict.value)"></el-option>
              </el-select>
            </el-form-item></el-col></el-row><el-row>
          <el-form-item label=" 题目 " prop="topic">
            <el-input v-model="form.topic" type="textarea" placeholder="请输入内容" />
          </el-form-item></el-row>
        <el-row><el-form-item label=" 归属机构 " prop="orgid">
            <el-input v-model="form.orgid" placeholder="请输入 机构ID " />
          </el-form-item></el-row> <el-row><el-col :span="8">
            <el-form-item label=" 是否隐藏 " prop="ishide">
              <el-select v-model="form.ishide" placeholder="请选择 是否隐藏 ">
                <el-option v-for="dict in dict.type.sys_yes_no" :key="dict.value" :label="dict.label"
                  :value="parseInt(dict.value)"></el-option>
              </el-select>
            </el-form-item>
          </el-col><el-col :span="8">
            <el-form-item label=" 删除标记 " prop="delFlag">
              <el-select v-model="form.delFlag" placeholder="请选择 删除标记 ">
                <el-option v-for="dict in dict.type.sys_yes_no" :key="dict.value" :label="dict.label"
                  :value="dict.value"></el-option>
              </el-select>
            </el-form-item></el-col></el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listSvytopic, getSvytopic, delSvytopic, addSvytopic, updateSvytopic } from "@/api/smartor/svytopic";

export default {
  name: "Svytopic",
  dicts: ['sys_yes_no'],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 问卷题目表格数据
      svytopicList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        oldid: null,
        topictype: null,
        topic: null,
        ishide: null,
        orgid: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        delFlag: [
          { required: true, message: " 删除标记 不能为空", trigger: "change" }
        ],
        isupload: [
          { required: true, message: " 上传标记 不能为空", trigger: "change" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询问卷题目列表 */
    getList() {
      this.loading = true;
      listSvytopic(this.queryParams).then(response => {
        this.svytopicList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        topicid: null,
        oldid: null,
        svyid: null,
        topictype: null,
        topiccode: null,
        topic: null,
        sort: null,
        ismandatory: null,
        ishide: null,
        delFlag: null,
        orgid: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        isupload: null,
        uploadTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.topicid)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加问卷题目";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const topicid = row.topicid || this.ids
      getSvytopic(topicid).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改问卷题目";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.topicid != null) {
            updateSvytopic(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addSvytopic(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const topicids = row.topicid || this.ids;
      this.$modal.confirm('是否确认删除问卷题目编号为"' + topicids + '"的数据项？').then(function () {
        return delSvytopic(topicids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('smartor/svytopic/export', {
        ...this.queryParams
      }, `svytopic_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
